Index: src/includes/classes/Smarty/sysplugins/smarty_internal_templatebase.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_templatebase.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_templatebase.php	(revision )
@@ -474,470 +106,294 @@
     public function display($template = null, $cache_id = null, $compile_id = null, $parent = null)
     {
         // display template
-        $this->fetch($template, $cache_id, $compile_id, $parent, true);
+        $this->_execute($template, $cache_id, $compile_id, $parent, 1);
     }
 
     /**
      * test if cache is valid
      *
-     * @param  string|object $template   the resource handle of the template file or template object
+     * @api  Smarty::isCached()
+     * @link http://www.smarty.net/docs/en/api.is.cached.tpl
+     *
+     * @param  null|string|\Smarty_Internal_Template $template   the resource handle of the template file or template object
-     * @param  mixed         $cache_id   cache id to be used with this template
+     * @param  mixed                                 $cache_id   cache id to be used with this template
-     * @param  mixed         $compile_id compile id to be used with this template
+     * @param  mixed                                 $compile_id compile id to be used with this template
-     * @param  object        $parent     next higher level of Smarty variables
+     * @param  object                                $parent     next higher level of Smarty variables
      *
      * @return boolean       cache status
      */
     public function isCached($template = null, $cache_id = null, $compile_id = null, $parent = null)
     {
-        if ($template === null && $this instanceof $this->template_class) {
-            return $this->cached->valid;
+        return $this->_execute($template, $cache_id, $compile_id, $parent, 2);
-        }
+    }
-        if (!($template instanceof $this->template_class)) {
-            if ($parent === null) {
-                $parent = $this;
-            }
-            $template = $this->smarty->createTemplate($template, $cache_id, $compile_id, $parent, false);
-        }
-        // return cache status of template
-        return $template->cached->valid;
-    }
 
     /**
-     * creates a data object
+     * fetches a rendered Smarty template
      *
+     * @param  string $template   the resource handle of the template file or template object
+     * @param  mixed  $cache_id   cache id to be used with this template
+     * @param  mixed  $compile_id compile id to be used with this template
-     * @param object $parent next higher level of Smarty variables
+     * @param  object $parent     next higher level of Smarty variables
+     * @param  string $function  function type 0 = fetch,  1 = display, 2 = isCache
      *
-     * @returns Smarty_Data data object
+     * @return mixed
+     * @throws \Exception
+     * @throws \SmartyException
      */
-    public function createData($parent = null)
+    private function _execute($template, $cache_id, $compile_id, $parent, $function)
     {
-        return new Smarty_Data($parent, $this);
+        $smarty = $this->_objType == 1 ? $this : $this->smarty;
+        if ($template === null) {
+            if ($this->_objType != 2) {
+                throw new SmartyException($function . '():Missing \'$template\' parameter');
+            } else {
+                $template = clone $this;
-    }
+            }
-
-    /**
-     * Registers plugin to be used in templates
-     *
-     * @param  string   $type       plugin type
-     * @param  string   $tag        name of template tag
-     * @param  callback $callback   PHP callback to register
-     * @param  boolean  $cacheable  if true (default) this fuction is cachable
-     * @param  array    $cache_attr caching attributes if any
-     *
-     * @return Smarty_Internal_Templatebase current Smarty_Internal_Templatebase (or Smarty or Smarty_Internal_Template) instance for chaining
-     * @throws SmartyException              when the plugin tag is invalid
-     */
-    public function registerPlugin($type, $tag, $callback, $cacheable = true, $cache_attr = null)
-    {
-        if (isset($this->smarty->registered_plugins[$type][$tag])) {
-            throw new SmartyException("Plugin tag \"{$tag}\" already registered");
-        } elseif (!is_callable($callback)) {
-            throw new SmartyException("Plugin \"{$tag}\" not callable");
+        } elseif (is_object($template)) {
+            if (!isset($template->_objType) || $template->_objType != 2) {
+                throw new SmartyException($function . '():Template object expected');
-        } else {
+            } else {
-            $this->smarty->registered_plugins[$type][$tag] = array($callback, (bool) $cacheable, (array) $cache_attr);
+                /* @var Smarty_Internal_Template $template */
+                $template = clone $template;
-        }
+            }
-
-        return $this;
+        } else {
+            // get template object
+            /* @var Smarty_Internal_Template $template */
+            $template = $smarty->createTemplate($template, $cache_id, $compile_id, $parent, false);
+            if ($this->_objType == 1) {
+                // set caching in template object
+                $template->caching = $this->caching;
-    }
+            }
-
-    /**
-     * Unregister Plugin
-     *
-     * @param  string $type of plugin
-     * @param  string $tag  name of plugin
-     *
-     * @return Smarty_Internal_Templatebase current Smarty_Internal_Templatebase (or Smarty or Smarty_Internal_Template) instance for chaining
-     */
-    public function unregisterPlugin($type, $tag)
-    {
-        if (isset($this->smarty->registered_plugins[$type][$tag])) {
-            unset($this->smarty->registered_plugins[$type][$tag]);
         }
-
-        return $this;
+        // fetch template content
+        $level = ob_get_level();
+        try {
+            $_smarty_old_error_level =
+                ($this->_objType == 1 && isset($smarty->error_reporting)) ? error_reporting($smarty->error_reporting) :
+                    null;
+            if ($function == 2) {
+                if ($template->caching) {
+                    // return cache status of template
+                    if (!isset($template->cached)) {
+                        $template->loadCached();
-    }
+                    }
+                    $result = $template->cached->isCached($template);
+                    $template->smarty->_cache['isCached'][$template->_getTemplateId()] = $template;
+                } else {
+                    return false;
+                }
+            } else {
+                ob_start();
+                $template->_mergeVars();
+                if (!empty(Smarty::$global_tpl_vars)) {
+                    $template->tpl_vars = array_merge(Smarty::$global_tpl_vars, $template->tpl_vars);
+                }
+                $result = $template->render(false, $function);
+            }
+            if (isset($_smarty_old_error_level)) {
+                error_reporting($_smarty_old_error_level);
+            }
-
+    
-    /**
-     * Registers a resource to fetch a template
-     *
-     * @param  string                $type     name of resource type
-     * @param  Smarty_Resource|array $callback or instance of Smarty_Resource, or array of callbacks to handle resource (deprecated)
-     *
-     * @return Smarty_Internal_Templatebase current Smarty_Internal_Templatebase (or Smarty or Smarty_Internal_Template) instance for chaining
-     */
-    public function registerResource($type, $callback)
-    {
-        $this->smarty->registered_resources[$type] = $callback instanceof Smarty_Resource ? $callback : array($callback, false);
+            $result = $this->_filterSessionIds($result);
-
+            
-        return $this;
+            return $result;
-    }
+        }
+        catch (Exception $e) {
+            while (ob_get_level() > $level) {
+                ob_end_clean();
+            }
+            throw $e;
+        }
+    }
 
     /**
-     * Unregisters a resource
+     * Registers plugin to be used in templates
      *
-     * @param  string $type name of resource type
+     * @api  Smarty::registerPlugin()
+     * @link http://www.smarty.net/docs/en/api.register.plugin.tpl
      *
-     * @return Smarty_Internal_Templatebase current Smarty_Internal_Templatebase (or Smarty or Smarty_Internal_Template) instance for chaining
+     * @param  string   $type       plugin type
+     * @param  string   $name       name of template tag
+     * @param  callback $callback   PHP callback to register
+     * @param  bool     $cacheable  if true (default) this function is cache able
+     * @param  mixed    $cache_attr caching attributes if any
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+     * @throws SmartyException              when the plugin tag is invalid
      */
-    public function unregisterResource($type)
+    public function registerPlugin($type, $name, $callback, $cacheable = true, $cache_attr = null)
     {
-        if (isset($this->smarty->registered_resources[$type])) {
-            unset($this->smarty->registered_resources[$type]);
+        return $this->ext->registerPlugin->registerPlugin($this, $type, $name, $callback, $cacheable, $cache_attr);
-        }
+    }
 
-        return $this;
-    }
-
     /**
-     * Registers a cache resource to cache a template's output
+     * load a filter of specified type and name
      *
-     * @param  string               $type     name of cache resource type
-     * @param  Smarty_CacheResource $callback instance of Smarty_CacheResource to handle output caching
+     * @api  Smarty::loadFilter()
+     * @link http://www.smarty.net/docs/en/api.load.filter.tpl
      *
-     * @return Smarty_Internal_Templatebase current Smarty_Internal_Templatebase (or Smarty or Smarty_Internal_Template) instance for chaining
+     * @param  string $type filter type
+     * @param  string $name filter name
+     *
+     * @return bool
+     * @throws SmartyException if filter could not be loaded
      */
-    public function registerCacheResource($type, Smarty_CacheResource $callback)
+    public function loadFilter($type, $name)
     {
-        $this->smarty->registered_cache_resources[$type] = $callback;
-
-        return $this;
+        return $this->ext->loadFilter->loadFilter($this, $type, $name);
     }
 
     /**
-     * Unregisters a cache resource
+     * Registers a filter function
      *
-     * @param  string $type name of cache resource type
+     * @api  Smarty::registerFilter()
+     * @link http://www.smarty.net/docs/en/api.register.filter.tpl
      *
-     * @return Smarty_Internal_Templatebase current Smarty_Internal_Templatebase (or Smarty or Smarty_Internal_Template) instance for chaining
+     * @param  string      $type filter type
+     * @param  callback    $callback
+     * @param  string|null $name optional filter name
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+     * @throws \SmartyException
      */
-    public function unregisterCacheResource($type)
+    public function registerFilter($type, $callback, $name = null)
     {
-        if (isset($this->smarty->registered_cache_resources[$type])) {
-            unset($this->smarty->registered_cache_resources[$type]);
+        return $this->ext->registerFilter->registerFilter($this, $type, $callback, $name);
-        }
+    }
 
-        return $this;
-    }
-
     /**
      * Registers object to be used in templates
      *
-     * @param          $object_name
-     * @param  object  $object_impl   the referenced PHP object to register
-     * @param  array   $allowed       list of allowed methods (empty = all)
-     * @param  boolean $smarty_args   smarty argument format, else traditional
+     * @api  Smarty::registerObject()
+     * @link http://www.smarty.net/docs/en/api.register.object.tpl
+     *
+     * @param  string $object_name
+     * @param  object $object                     the referenced PHP object to register
+     * @param  array  $allowed_methods_properties list of allowed methods (empty = all)
+     * @param  bool   $format                     smarty argument format, else traditional
-     * @param  array   $block_methods list of block-methods
+     * @param  array  $block_methods              list of block-methods
      *
-     * @throws SmartyException
-     * @return Smarty_Internal_Templatebase current Smarty_Internal_Templatebase (or Smarty or Smarty_Internal_Template) instance for chaining
+     * @return \Smarty|\Smarty_Internal_Template
+     * @throws \SmartyException
      */
-    public function registerObject($object_name, $object_impl, $allowed = array(), $smarty_args = true, $block_methods = array())
+    public function registerObject($object_name, $object, $allowed_methods_properties = array(), $format = true,
+                                   $block_methods = array())
     {
-        // test if allowed methods callable
-        if (!empty($allowed)) {
-            foreach ((array) $allowed as $method) {
-                if (!is_callable(array($object_impl, $method)) && !property_exists($object_impl, $method)) {
-                    throw new SmartyException("Undefined method or property '$method' in registered object");
+        return $this->ext->registerObject->registerObject($this, $object_name, $object, $allowed_methods_properties,
+                                                          $format, $block_methods);
-                }
+    }
-            }
-        }
-        // test if block methods callable
-        if (!empty($block_methods)) {
-            foreach ((array) $block_methods as $method) {
-                if (!is_callable(array($object_impl, $method))) {
-                    throw new SmartyException("Undefined method '$method' in registered object");
-                }
-            }
-        }
-        // register the object
-        $this->smarty->registered_objects[$object_name] =
-            array($object_impl, (array) $allowed, (boolean) $smarty_args, (array) $block_methods);
 
-        return $this;
-    }
-
     /**
-     * return a reference to a registered object
-     *
-     * @param  string $name object name
-     *
-     * @return object
-     * @throws SmartyException if no such object is found
+     * @param boolean $caching
      */
-    public function getRegisteredObject($name)
+    public function setCaching($caching)
     {
-        if (!isset($this->smarty->registered_objects[$name])) {
-            throw new SmartyException("'$name' is not a registered object");
+        $this->caching = $caching;
-        }
+    }
-        if (!is_object($this->smarty->registered_objects[$name][0])) {
-            throw new SmartyException("registered '$name' is not an object");
-        }
 
-        return $this->smarty->registered_objects[$name][0];
-    }
-
     /**
-     * unregister an object
-     *
-     * @param  string $name object name
-     *
-     * @return Smarty_Internal_Templatebase current Smarty_Internal_Templatebase (or Smarty or Smarty_Internal_Template) instance for chaining
+     * @param int $cache_lifetime
      */
-    public function unregisterObject($name)
+    public function setCacheLifetime($cache_lifetime)
     {
-        if (isset($this->smarty->registered_objects[$name])) {
-            unset($this->smarty->registered_objects[$name]);
+        $this->cache_lifetime = $cache_lifetime;
-        }
+    }
 
-        return $this;
-    }
-
     /**
-     * Registers static classes to be used in templates
-     *
-     * @param         $class_name
-     * @param  string $class_impl the referenced PHP class to register
-     *
-     * @throws SmartyException
-     * @return Smarty_Internal_Templatebase current Smarty_Internal_Templatebase (or Smarty or Smarty_Internal_Template) instance for chaining
+     * @param string $compile_id
      */
-    public function registerClass($class_name, $class_impl)
+    public function setCompileId($compile_id)
     {
-        // test if exists
-        if (!class_exists($class_impl)) {
-            throw new SmartyException("Undefined class '$class_impl' in register template class");
+        $this->compile_id = $compile_id;
-        }
+    }
-        // register the class
-        $this->smarty->registered_classes[$class_name] = $class_impl;
 
-        return $this;
-    }
-
     /**
-     * Registers a default plugin handler
-     *
-     * @param  callable $callback class/method name
-     *
-     * @return Smarty_Internal_Templatebase current Smarty_Internal_Templatebase (or Smarty or Smarty_Internal_Template) instance for chaining
-     * @throws SmartyException              if $callback is not callable
+     * @param string $cache_id
      */
-    public function registerDefaultPluginHandler($callback)
+    public function setCacheId($cache_id)
     {
-        if (is_callable($callback)) {
-            $this->smarty->default_plugin_handler_func = $callback;
-        } else {
-            throw new SmartyException("Default plugin handler '$callback' not callable");
+        $this->cache_id = $cache_id;
-        }
-
+    }
+    
-        return $this;
-    }
-
     /**
-     * Registers a default template handler
+     * Checks if the SessionID in a HTML-Element (e.g. a link) matches the current SessionID.
+     * If not it will replace it with the current SessionID to avoid security problems.
      *
-     * @param  callable $callback class/method name
-     *
-     * @return Smarty_Internal_Templatebase current Smarty_Internal_Templatebase (or Smarty or Smarty_Internal_Template) instance for chaining
-     * @throws SmartyException              if $callback is not callable
+     * @param string $p_output
+     * @return string
      */
-    public function registerDefaultTemplateHandler($callback)
+    protected function _filterSessionIds($p_output)
     {
-        if (is_callable($callback)) {
-            $this->smarty->default_template_handler_func = $callback;
-        } else {
-            throw new SmartyException("Default template handler '$callback' not callable");
-        }
+        $newSid	= xtc_session_id();
+        $sessStr = 'XTCsid';
+        $sessLength = strlen($newSid);
+        $agent = false;
-
+        
-        return $this;
+        if(function_exists('xtc_check_agent'))
+        {
+            $agent = xtc_check_agent();
-    }
-
+        }
+        
-    /**
-     * Registers a default template handler
-     *
-     * @param  callable $callback class/method name
-     *
-     * @return Smarty_Internal_Templatebase current Smarty_Internal_Templatebase (or Smarty or Smarty_Internal_Template) instance for chaining
-     * @throws SmartyException              if $callback is not callable
-     */
-    public function registerDefaultConfigHandler($callback)
+        $pattern  = '/&(' . $sessStr . ')=[a-zA-Z0-9,-]{' . $sessLength . '}/s';
+        $replace = '';
+        if(!$agent)
-    {
+        {
-        if (is_callable($callback)) {
-            $this->smarty->default_config_handler_func = $callback;
-        } else {
-            throw new SmartyException("Default config handler '$callback' not callable");
+            $replace  = '&$1=' . $newSid;
         }
-
+        
-        return $this;
-    }
+        $output = preg_replace($pattern, $replace, $p_output);
-
+        
-    /**
-     * Registers a filter function
-     *
-     * @param  string   $type filter type
-     * @param  callback $callback
-     *
-     * @return Smarty_Internal_Templatebase current Smarty_Internal_Templatebase (or Smarty or Smarty_Internal_Template) instance for chaining
-     */
-    public function registerFilter($type, $callback)
+        $pattern  = '/&amp;(' . $sessStr . ')=[a-zA-Z0-9,-]{' . $sessLength . '}/s';
+        $replace = '';
+        if(!$agent)
-    {
+        {
-        $this->smarty->registered_filters[$type][$this->_get_filter_name($callback)] = $callback;
-
-        return $this;
+            $replace  = '&amp;$1=' . $newSid;
-    }
-
+        }
+        
-    /**
-     * Unregisters a filter function
-     *
-     * @param  string   $type filter type
-     * @param  callback $callback
-     *
-     * @return Smarty_Internal_Templatebase current Smarty_Internal_Templatebase (or Smarty or Smarty_Internal_Template) instance for chaining
-     */
-    public function unregisterFilter($type, $callback)
+        $output = preg_replace($pattern, $replace, $output);
+        
+        $pattern  = '/\?(' . $sessStr . ')=[a-zA-Z0-9,-]{' . $sessLength . '}([^&])/s';
+        $replace = '$2';
+        if(!$agent)
-    {
+        {
-        $name = $this->_get_filter_name($callback);
-        if (isset($this->smarty->registered_filters[$type][$name])) {
-            unset($this->smarty->registered_filters[$type][$name]);
+            $replace  = '?$1=' . $newSid . '$2';
         }
-
+        
-        return $this;
-    }
+        $output = preg_replace($pattern, $replace, $output);
-
+        
-    /**
-     * Return internal filter name
-     *
-     * @param  callback $function_name
-     *
-     * @return string   internal filter name
-     */
-    public function _get_filter_name($function_name)
+        $pattern  = '/\?(' . $sessStr . ')=([a-zA-Z0-9,-]{' . $sessLength . '})&amp;/s';
+        $replace = '?';
+        if(!$agent)
-    {
+        {
-        if (is_array($function_name)) {
-            $_class_name = (is_object($function_name[0]) ?
-                get_class($function_name[0]) : $function_name[0]);
-
-            return $_class_name . '_' . $function_name[1];
-        } else {
-            return $function_name;
+            $replace  = '?$1=' . $newSid . '&amp;';
         }
-    }
-
+        
-    /**
-     * load a filter of specified type and name
-     *
-     * @param  string $type filter type
-     * @param  string $name filter name
-     *
-     * @throws SmartyException if filter could not be loaded
-     */
-    public function loadFilter($type, $name)
-    {
-        $_plugin = "smarty_{$type}filter_{$name}";
-        $_filter_name = $_plugin;
-        if ($this->smarty->loadPlugin($_plugin)) {
-            if (class_exists($_plugin, false)) {
-                $_plugin = array($_plugin, 'execute');
-            }
-            if (is_callable($_plugin)) {
-                $this->smarty->registered_filters[$type][$_filter_name] = $_plugin;
+        $output = preg_replace($pattern, $replace, $output);
-
+        
-                return true;
-            }
-        }
-        throw new SmartyException("{$type}filter \"{$name}\" not callable");
-    }
-
-    /**
-     * unload a filter of specified type and name
-     *
-     * @param  string $type filter type
-     * @param  string $name filter name
-     *
-     * @return Smarty_Internal_Templatebase current Smarty_Internal_Templatebase (or Smarty or Smarty_Internal_Template) instance for chaining
-     */
-    public function unloadFilter($type, $name)
+        $pattern  = '/\?(' . $sessStr . ')=([a-zA-Z0-9,-]{' . $sessLength . '})&/s';
+        $replace = '?';
+        if(!$agent)
-    {
+        {
-        $_filter_name = "smarty_{$type}filter_{$name}";
-        if (isset($this->smarty->registered_filters[$type][$_filter_name])) {
-            unset ($this->smarty->registered_filters[$type][$_filter_name]);
+            $replace  = '?$1=' . $newSid . '&';
         }
-
+        
-        return $this;
-    }
+        $output = preg_replace($pattern, $replace, $output);
-
+        
-    /**
-     * preg_replace callback to convert camelcase getter/setter to underscore property names
-     *
-     * @param  string $match match string
-     *
-     * @return string replacemant
-     */
-    private function replaceCamelcase($match)
+        $pattern  = '/(<input[^>]+name="' . $sessStr . '"[^>]+value=")([a-zA-Z0-9,-]{' . $sessLength . '})("[^>]*>)/s';
+        $replace = '';
+        if(!$agent)
-    {
+        {
-        return "_" . strtolower($match[1]);
+            $replace  = '${1}' . $newSid . '$3';
-    }
+        }
+        $output = preg_replace($pattern, $replace , $output);
-
+        
-    /**
-     * Handle unknown class methods
-     *
-     * @param string $name unknown method-name
-     * @param array  $args argument array
-     *
-     * @throws SmartyException
-     */
-    public function __call($name, $args)
+        $pattern  = '/(<input[^>]+value=")([a-zA-Z0-9,-]{' . $sessLength . '})("[^>]+name="' . $sessStr . '"[^>]*>)/s';
+        if(!$agent)
-    {
+        {
-        static $_prefixes = array('set' => true, 'get' => true);
-        static $_resolved_property_name = array();
-        static $_resolved_property_source = array();
-
-        // method of Smarty object?
-        if (method_exists($this->smarty, $name)) {
-            return call_user_func_array(array($this->smarty, $name), $args);
+            $replace  = '${1}' . $newSid . '$3';
         }
-        // see if this is a set/get for a property
-        $first3 = strtolower(substr($name, 0, 3));
-        if (isset($_prefixes[$first3]) && isset($name[3]) && $name[3] !== '_') {
-            if (isset($_resolved_property_name[$name])) {
-                $property_name = $_resolved_property_name[$name];
-            } else {
-                // try to keep case correct for future PHP 6.0 case-sensitive class methods
-                // lcfirst() not available < PHP 5.3.0, so improvise
-                $property_name = strtolower(substr($name, 3, 1)) . substr($name, 4);
-                // convert camel case to underscored name
-                $property_name = preg_replace_callback('/([A-Z])/', array($this, 'replaceCamelcase'), $property_name);
-                $_resolved_property_name[$name] = $property_name;
-            }
-            if (isset($_resolved_property_source[$property_name])) {
-                $_is_this = $_resolved_property_source[$property_name];
-            } else {
-                $_is_this = null;
-                if (property_exists($this, $property_name)) {
-                    $_is_this = true;
-                } elseif (property_exists($this->smarty, $property_name)) {
-                    $_is_this = false;
-                }
-                $_resolved_property_source[$property_name] = $_is_this;
-            }
-            if ($_is_this) {
-                if ($first3 == 'get') {
-                    return $this->$property_name;
-                } else {
-                    return $this->$property_name = $args[0];
-                }
-            } elseif ($_is_this === false) {
-                if ($first3 == 'get') {
-                    return $this->smarty->$property_name;
-                } else {
-                    return $this->smarty->$property_name = $args[0];
-                }
-            } else {
-                throw new SmartyException("property '$property_name' does not exist.");
-           }
-        }
-        if ($name == 'Smarty') {
-            throw new SmartyException("PHP5 requires you to call __construct() instead of Smarty()");
-        }
-        // must be unknown
-        throw new SmartyException("Call of unknown method '$name'.");
+        $output = preg_replace($pattern, $replace, $output);
+        
+        return $output;
     }
 }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compilebase.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compilebase.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compilebase.php	(revision )
@@ -21,6 +21,7 @@
      * @var array
      */
     public $required_attributes = array();
+
     /**
      * Array of names of optional attribute required by tag
      * use array('_any') if there is no restriction of attributes names
@@ -28,12 +29,14 @@
      * @var array
      */
     public $optional_attributes = array();
+
     /**
      * Shorttag attribute order defined by its names
      *
      * @var array
      */
     public $shorttag_order = array();
+
     /**
      * Array of names of valid option flags
      *
@@ -68,7 +71,7 @@
                     $_indexed_attr[$this->shorttag_order[$key]] = $mixed;
                 } else {
                     // too many shorthands
-                    $compiler->trigger_template_error('too many shorthand attributes', $compiler->lex->taglineno);
+                    $compiler->trigger_template_error('too many shorthand attributes', null, true);
                 }
                 // named attribute
             } else {
@@ -90,7 +93,7 @@
                             $_indexed_attr[$kv['key']] = false;
                         }
                     } else {
-                        $compiler->trigger_template_error("illegal value of option flag \"{$kv['key']}\"", $compiler->lex->taglineno);
+                        $compiler->trigger_template_error("illegal value of option flag \"{$kv['key']}\"", null, true);
                     }
                     // must be named attribute
                 } else {
@@ -102,7 +105,7 @@
         // check if all required attributes present
         foreach ($this->required_attributes as $attr) {
             if (!array_key_exists($attr, $_indexed_attr)) {
-                $compiler->trigger_template_error("missing \"" . $attr . "\" attribute", $compiler->lex->taglineno);
+                $compiler->trigger_template_error("missing \"" . $attr . "\" attribute", null, true);
             }
         }
         // check for not allowed attributes
@@ -110,7 +113,7 @@
             $tmp_array = array_merge($this->required_attributes, $this->optional_attributes, $this->option_flags);
             foreach ($_indexed_attr as $key => $dummy) {
                 if (!in_array($key, $tmp_array) && $key !== 0) {
-                    $compiler->trigger_template_error("unexpected \"" . $key . "\" attribute", $compiler->lex->taglineno);
+                    $compiler->trigger_template_error("unexpected \"" . $key . "\" attribute", null, true);
                 }
             }
         }
@@ -162,12 +165,13 @@
                 }
             }
             // wrong nesting of tags
-            $compiler->trigger_template_error("unclosed {$compiler->smarty->left_delimiter}" . $_openTag . "{$compiler->smarty->right_delimiter} tag");
+            $compiler->trigger_template_error("unclosed {$compiler->smarty->left_delimiter}" . $_openTag .
+                                              "{$compiler->smarty->right_delimiter} tag");
 
             return;
         }
         // wrong nesting of tags
-        $compiler->trigger_template_error("unexpected closing tag", $compiler->lex->taglineno);
+        $compiler->trigger_template_error("unexpected closing tag", null, true);
 
         return;
     }
